//Arduino to RB Communications Project
//Program_02.Bas
Port = 3   //change this as per your system
Main:
   GoSub Initialization
   while true
      new_LED = GetSliderPos("LED")
      if new_LED != old_LED
         xystring 530,180,new_LED,spaces(30)
         old_LED = new_LED
         serialout new_LED
      endif
      call GetPot(new_Pot)
      if new_Pot != old_Pot
         xystring 530,100,new_Pot,spaces(30)
         SetSliderPos "Pot",new_Pot
         old_Pot = new_Pot
      endif
   wend
End
//------------------------------------------
Initialization:
   old_Pot = 2000 \ old_LED = 2000
   new_Pot = 0 \ new_LED = 0
   setcommport Port,br115200    //init the serial port
   addslider "Pot",100,100,400,0,1024 \ EnableSlider "Pot",false
   addslider "LED",100,180,400,0,255
   xystring 200,75,"Arduino Pot Position"
   xystring 200,155,"Arduino LED brightness"
Return
//------------------------------------------
sub GetPot(&a)
   CheckSerBuffer n
   if n >1
      Serin s
      a = (GetStrByte(s,1) << 8)+GetStrByte(s,2)
   endif
Return
