//Arduino to RB Communications Project
//Program_03.Bas
Port = 3   //change this as per your system
Main:
   GoSub Initialization
   while true
      if LastButton() != ""  //if button pushed
          xyText 500,200,spaces(50),,20,fs_Bold
          call CreateTheBuffer(s,x)
          Serialout s \  SerBytesIn x,r,n
          if n == x //buffer received back correctly
             call ExtractTheBuffer(r)
          else //communications process failed
              xyText 500,200,"Comms Error",,20,fs_Bold,red
          endif        
      endif
   wend
End
//------------------------------------------
Initialization:
   setcommport Port,br115200
   xyText      40,55,"Code"
   xyText      40,95,"Name"
   xyText      40,135,"Birth Year"
   xyText      40,175,"Address"  
   xyText      40,215,"Zip Code"  
   xyText      40,255,"Balance"  
   AddEdit     "Code",135,55,85
   AddEdit     "Name",135,95,207
   AddEdit     "Birth Year",135,135,87
   AddEdit     "Address",135,175,319
   AddEdit     "Zip Code",135,215
   AddEdit     "Balance",135,255,140
   AddButton   "&Send",263,355,115,43
   IntegerEdit "Code"     \ IntegerEdit "Birth Year"
   IntegerEdit "Zip Code" \ FloatEdit "Balance"
   FocusEdit "Code"
Return
//------------------------------------------
sub CreateTheBuffer(&s,&x)
    //creat the buffer to be sent with all the data from the edit boxes
    s  = toByte(ToNumber(GetEdit("Code"),0))
    a  = GetEdit("Name") \ L = Limit(Length(a),0,255)
    s += tobyte(L)+Left(a,L)
    n  = ToNumber(GetEdit("Birth Year"),0)
    s += toByte(n)+toByte(n >> 8) //LSBFirst
    a  = GetEdit("Address") \ L = Limit(Length(a),0,255)
    s += tobyte(L)+Left(a,L)
    s += BuffWrite("",0,ToNumber(GetEdit("Zip Code"),0))
    s += BuffWriteF32("",0,ToNumber(GetEdit("Balance"),0)*1.0)
    x  = Length(s)+4
    s  = BuffWrite("",0,x)+s  //prefix the buffer with its length
Return
//------------------------------------------
sub ExtractTheBuffer(s)
   //extract the fields from the received buffer and set the edit boxes
   //accordingly
   SetEdit "Code",GetStrByte(s,5)
   n = GetStrByte(s,6)
   SetEdit "Name",BuffRead(s,6,n) \ n += 6
   SetEdit "Birth Year",(GetStrByte(s,n+2)<<8)+GetStrByte(s,n+1) //LSBFirst
   n+=2
   c = GetStrByte(s,n+1)\ n++
   SetEdit "Address", BuffRead(s,n,c) \ n+=c
   SetEdit "Zip Code",BuffReadI(s,n) \ n+=BytesCount_I
   SetEdit "Balance",BuffreadF32(s,n)   
   FocusEdit "Code"
Return
