//Arduino to RB Communications Protocol Implementation
//Program_04.Bas
Port = 0   //change this as per your system
TCPS_IP = "192.168.0.196" \ TCPS_Port = 50001
tcpc_Connect(TCPS_IP,TCPS_Port)
#include ".\Instruments.Bas"
Main:
  InlineInputmode
  setcommport Port,br115200
  print "Initializing ....please wait...."
  delay 2000
  C = 0 \ P = 0
  while true
    clearscr
    print "1- Play a note"
    print "2- Set the brightness"
    print "3- Set the blink rate"
    print "....... select an option:",crlf()
    repeat
        m = spaces(40)
        Call SendCommand(2,0,Button,Pot,Ok)
        if !Ok then m = "Comms error"
        xyString 600,10,m 
        xyString 300,10, "Button Status     Pot Value"
        xystring 340,35,Button,spaces(15),Pot,spaces(24)
        GetKey K \ K = char(K)
    until Instring("123",K)
    if K == "1"
      Input "Enter the note number (0-84):",N
      call SendCommand(73,N)
    elseif K == "2"
      Input "Enter the desired brightness level (0-255):",N
      call SendCommand(3,N)
    elseif K == "3"
      Input "Enter the blink rate (0-255):",N
      call SendCommand(4,N)
    endif
  wend
End
//------------------------------------------
sub SendCommand(Command,Parameter,&A,&B,&Status)
  A = -1 \ B = -1 \ Status = false
  if Command < 0 then return false
  //ClearSerBuffer \ serialout Command,Parameter
  //serbytesin 5,s,x
  Call TCP_SendCommand(Command,Parameter,s,x)
  if x < 5 then  return false
  A = GetStrByte(s,1)                         //get the Pushbutton
  B = (GetStrByte(s,4) << 8)+GetStrByte(s,5)  //create the return value
  Status = true
Return true
//--------------------------------------------

