//Arduino to RB Communications Project
//Program_03.Pde
#define LED_Pin 13   //LED digital pin
int Interval =500; //blink rate
char Mode = 0;       //LED status
long t;              //stop watch timer  
char buff[600];      //buffer to hold data
int received = 0;
long count=0;  
      
//-----define function templates
void manipulateBuffer();
void Capitalize(char *c);
//---------------------------------
//---------------------------------
void setup() 
{
  Serial.begin(115200);     //init serial comms
  pinMode(LED_Pin,OUTPUT);
  t = millis();
}
//---------------------------------
void loop() 
{
  if(millis()-t > Interval)  //if timed out toggle the LED
  {
     Mode = !Mode; 
     t = millis(); digitalWrite(LED_Pin,Mode);
  }
  if(Serial.available() > 0)   //any bytes
      buff[received++] = Serial.read(); //copy them to the secondary buffer
  if((received >= 4) && (count == 0))
     count = *(long *)buff;
  if((count > 0) && (received >= count))
  {
    manipulateBuffer();   
    Serial.write((unsigned char *)buff,count);
    Serial.flush();
    received = count = 0; //restart the waiting   
  }
}
//------------------------------------
void manipulateBuffer()
{
   //add 1 to all numerical fields
   buff[4]++ ; //Code
   int N,BY,Add,ZC,Bln;  //field position index
   //calculate indexes into the buffer for all fields
   N = 6;
   BY = buff[5]+6;
   Add = BY+3;
   ZC = Add+buff[Add-1];
   Bln = ZC+4;
   
   //increment Birth year (int 16 bit)also use it to set the Blinker rate
   Interval = (*(int *)(buff+BY))++;     
   (*(long *)(buff+ZC))++;   //increment the Zip code (long 32-bit)
   (*(float *)(buff+Bln))++; //increment the Balance (float 32-bit)
 
   //capitalize the Name and Address
   for(int i=0; i< buff[5];i++)
      Capitalize(buff+i+N);
   for(int i=0; i< buff[Add-1];i++)
      Capitalize(buff+i+Add);
}
//---------------------------------
void Capitalize(char *c)
{
   if (*c >= 'a' && *c <= 'z')
      *c += 'A'-'a';
}

